//
// Frdric Boulanger
// Suplec - Dpartement Informatique
// 3 rue Joliot-Curie
// 91192 Gif-sur-Yvette cedex, France
//
// frederic.boulanger@supelec.fr
//
/**
 * Forme d'onde sinusodale.
 */
class FormeSinus extends FormeOnde {
  /**
   * Cre une forme d'onde sinusodale de frquence <code>f0</code>
   *  la frquence d'chantillonnage <code>fe</code>.
   */
  public FormeSinus(double f0, double fe) {
    super(f0, fe);
  }

  /**
   * Calcule un chantillon de la sinusode.
   */
  public double echantillon(int i) {
    double periode = 1 / f0_;  // priode du signal
    // On se ramne dans la priode [0, periode[
    double t = Math.IEEEremainder(i/fe_, periode);
    // IEEEremainder nous ramne dans [-periode/2, periode/2[,
    // on ajoute donc periode au rsultat si t est ngatif.
    if (t < 0) {
      t += periode;
    }
    // On calcule f(t) = sin(2*pi*f*t)
    return Math.sin(2 * Math.PI * f0_ * t);
  }
}
